declare name 		"WindMgCr3";
declare version 	"1.03";
declare author 		"LP";
declare license 	"BSD";
declare copyright 	"(c)CIEREC 2017-2020";
//-----------------------------------------------
// WindMgCr3
//-----------------------------------------------
import("stdfaust.lib");

moog_vcf_wind =  ve.moog_vcf(res,freq) * 0.5; // fix select normalized

gain = hslider("[1]Gain", 0.2, 0, 1, 0.01):si.smooth(0.9997);
note = hslider("[2]MIDI", 60, 41, 93, 0.01):si.smooth(0.9997);
res  = hslider("[3]Res", 0.8, 0, 0.999, 0.001):si.smooth(0.9997);

crounch  = hslider("[4]Crounch", 0.0, 0, 1, 0.01):si.smooth(0.9997);

freq = ba.pianokey2hz(note);
//----------------------- NOISEBURST ------------------------- 
noiseburst = no.noise : *(gate : trigger(P))
	with { 
	upfront(x) = (x-x') > 0; 
	decay(n,x) = x - (x>0)/n; 
	release(n) = + ~ decay(n); 
	trigger(n) = upfront : release(n) : > (0.0);
	};
	
P = freq2; // fundamental period in samples 
Pmax = 4096; // maximum P (for delay-line allocation)

gate = phasor(1) :-(0.001):pulsar;
gain22 = 1;
freq2 = hslider("[5]Grain Size", 200,100,2205,1);
// la fréquence donne la largeur de bande extraite du bruit blanc

// PHASOR //////////////////////////////
phasor(init) =  (+(float(speed)/float(ma.SR)) : fmod(_,1.0)) ~ *(init);
						
// PULSAR //////////////////////////////
//Le pulsar permet de créer une 'pulsation' plus ou moins aléatoire (proba).
pulsar = _<:((_<(ratio_env)):@(100))*(proba>(_,abs(no.noise):ba.latch)); 
speed = hslider ("[6]Speed[unit:Hz]", 10,1,20,0.0001):fi.lowpass(1,1); 
ratio_env = 0.5;
fade = (0.5); // min > 0 pour eviter division par 0
proba = hslider ("[7]Probability[unit:%]", 70,50,100,1) * (0.01):fi.lowpass(1,1);
duree_env = 1/(speed: / (ratio_env*(0.25)*fade));

tbar		= 0.1;					// attack/release time in seconds
gbar		= exp(-1/(ma.SR*tbar));	// corresponding gain factor
envbar		= abs : *(1-gbar) : + ~ *(gbar) : ba.linear2db;
meter(x)	= attach(x, envbar(x) : hbargraph("level", -96, 10));	
			
process= no.noise * (1 - crounch) + noiseburst * crounch * 2 :*(gain) :
	moog_vcf_wind :max(-0.99):min(0.99) : meter <: _,_;		